#!/usr/bin/perl -w

use strict;
use Socket;

my $host = 'dropveter.snt.utwente.nl';

$ENV{PATH} = '/usr/local/bin:/usr/bin:/bin';

my $logprio = 14; # user.info = (LOG_USER (=1<<3) | LOG_INFO (=6))
my $time = substr(scalar localtime, 4, 15);
my $hostname = `hostname`;
chomp $hostname;
$hostname =~ s/\..*$//g;

$host = inet_aton($host) or warn "inet_aton: $!\n";

socket(my $sock, PF_INET, SOCK_DGRAM, getprotobyname('udp'))
	or warn "socket: $!\n";

my $destpaddr = sockaddr_in(514, $host) or warn "sockaddr_in: $!\n";

chdir '/etc/snt-mon'
	or die "Could not chdir to /etc/snt-mon: $!\n";

my $ts = time;
if (opendir DIR, 'plugins/') {
	while (my $file = readdir DIR) {
		next if $file =~ /^\./;
		next if $file =~ /\.dpkg-/;
		next if $file =~ /\.old$/;
		next if $file =~ /~$/;
		$file = "plugins/$file";
		if ( -f $file && -x $file ) {

			if (open STAT, "$file |") {
				my @lines = <STAT>;
				close STAT;

				foreach my $line (@lines) {
					chomp $line;
					$line = "<$logprio>$time $hostname STATS: [$ts] $line\n";
#					print $line;
					send($sock, $line, 0, $destpaddr)
						or warn "send: $!\n";
				}
			} else {
				warn "Could not execute '$file': $!\n";
			}
		}
	}
} else {
	warn "Missing plugins dir: $!\n";
}
